/* TTMPConn.h
 *
 * Private TTMPConnection declarations.
 *
 * Copyright (C) 2005-2006 TomTom BV <http://www.tomtom.com/>
 * Author 0: Dimitry Andric <dimitry.andric@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2
 * as published by the Free Software Foundation.
 */

#ifndef INCLUDED_TTMPCONN_H
#define INCLUDED_TTMPCONN_H

#include "TTMPSock.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TTMP_CON_MAGIC 0x0c45d101

typedef enum eTTMPSendState {
	SS_SILENT,
	SS_CONNECTED,
	SS_SLEEPING,
	SS_MESSAGE,
} TTMPSendState;

typedef enum eTTMPRecvState {
	RS_SILENT,
	RS_CONNECTED,
	RS_SLEEPING,
	RS_HEADER,
	RS_CONTENTS,
} TTMPRecvState;

struct sTTMPConnection {
	TUint32 magic;
	TInt32 timeout;
	TInt32 major;
	TInt32 minor;
	TTMPSendState sendstate;
	TTMPRecvState recvstate;
	TTMPSocket socket;
	TTMPBuffer sendbuf;
	TTMPBuffer recvbuf;
};

int TTMPConnectionCreateInternal(TTMPConnection *conn, TInt32 timeout, TInt32 major, TInt32 minor, TTMPSocket sock);
int TTMPConnectionCheckVersion(TTMPConnection conn, TInt32 timeout);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* INCLUDED_TTMPCONN_H */

/* EOF */
