/* TTMPPriv.h
 *
 * Private common TTMP declarations.
 *
 * Copyright (C) 2005-2006 TomTom BV <http://www.tomtom.com/>
 * Author 0: Dimitry Andric <dimitry.andric@tomtom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2
 * as published by the Free Software Foundation.
 */

#ifndef INCLUDED_TTMPPRIV_H
#define INCLUDED_TTMPPRIV_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TTMP_PROTO_VER 0x00010001

#define CHECK_OBJ(_type, _obj)                      \
	do {                                            \
		if ((_obj) == NULL)                         \
			return TTMP_ERR_##_type##NULL;          \
		if ((_obj)->magic != TTMP_##_type##_MAGIC)  \
			return TTMP_ERR_##_type##INVAL;         \
	} while (0)

#define CHECK_TIMEOUT(_to)                       \
	do {                                         \
		if ((_to) >= 0) {                        \
			break;                               \
	    } else if ((_to) == TTMP_TO_INFINITE) {  \
			break;                               \
		} else if ((_to) == TTMP_TO_DEFAULT) {   \
			(_to) = TTMP_TO_DEFVAL;              \
			break;                               \
		} else {                                 \
			return TTMP_ERR_ARGUMENT;            \
		}                                        \
	} while (0)

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* INCLUDED_TTMPPRIV_H */

/* EOF */
